<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>pam_pkcs11: pam-pkcs11-ossl-compat.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">pam_pkcs11
   &#160;<span id="projectnumber">0.6.11</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',false,false,'search.php','Search');
});
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_fdedb0aba14d44ce9d99bc100e026e6a.html">common</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">pam-pkcs11-ossl-compat.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="pam-pkcs11-ossl-compat_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * sc-ossl-compat.h: OpenSC ecompatability for older OpenSSL versions</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Copyright (C) 2016   Douglas E. Engert &lt;deengert@gmail.com&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * This library is free software; you can redistribute it and/or</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * modify it under the terms of the GNU Lesser General Public</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * License as published by the Free Software Foundation; either</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * version 2.1 of the License, or (at your option) any later version.</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * This library is distributed in the hope that it will be useful,</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * Lesser General Public License for more details.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * You should have received a copy of the GNU Lesser General Public</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> * License along with this library; if not, write to the Free Software</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#ifndef _PAM_PKCS11_OSSL_COMPAT_H</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#define _PAM_PKCS11_OSSL_COMPAT_H</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#ifdef __cplusplus</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;openssl/opensslv.h&gt;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;openssl/opensslconf.h&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * Provide backward compatability to older versions of OpenSSL</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * while using most of OpenSSL 1.1  API</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> * EVP_CIPHER_CTX functions:</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> * EVP_CIPHER_CTX_new       not in 0.9.7</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="comment"> * EVP_CIPHER_CTX_free      not in 0.9.7</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment"> * EVP_CIPHER_CTX_init      in 0.9.7 to 1.0.2. defined in 1.1 as EVP_CIPHER_CTX_reset</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> * EVP_CIPHER_CTX_cleanup   in 0.9.7 to 1.0.2, defined in 1.1 as EVP_CIPHER_CTX_reset</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * EVP_CIPHER_CTX_reset     only in 1.1</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> * EVP_CIPHER_CTX_new       does a EVP_CIPHER_CTX_init</span></div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="comment"> * EVP_CIPHER_CTX_free      does a EVP_CIPHER_CTX_cleanup</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="comment"> * EVP_CIPHER_CTX_cleanup   does equivelent of a EVP_CIPHER_CTX_init</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="comment"> * Use EVP_CIPHER_CTX_new, EVP_CIPHER_CTX_free, and  EVP_CIPHER_CTX_cleanup between operations</span></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="preprocessor">#if OPENSSL_VERSION_NUMBER  &lt;= 0x009070dfL</span></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="comment">/* in 0.9.7  EVP_CIPHER_CTX was always allocated inline or in other structures */</span></div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#af0eb08b2611f47eeaf57bf21d58b13e9">   54</a></span>&#160;<span class="preprocessor">#define EVP_CIPHER_CTX_new() ({ \</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="preprocessor">        EVP_CIPHER_CTX * tmp = NULL; \</span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="preprocessor">        tmp = OPENSSL_malloc(sizeof(struct evp_cipher_ctx_st)); \</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="preprocessor">        if (tmp) { \</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="preprocessor">        EVP_CIPHER_CTX_init(tmp); \</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="preprocessor">        } \</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="preprocessor">        tmp; \</span></div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="preprocessor">        })</span></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a65b40ec2b22b3886713618825118f03a">   63</a></span>&#160;<span class="preprocessor">#define EVP_CIPHER_CTX_free(x) ({ \</span></div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="preprocessor">        if (x) { \</span></div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="preprocessor">                EVP_CIPHER_CTX_cleanup(x); \</span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="preprocessor">                OPENSSL_free(x); \</span></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="preprocessor">        } \</span></div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="preprocessor">        })</span></div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* OPENSSL_VERSION_NUMBER =&lt; 0x00907000L */</span><span class="preprocessor"></span></div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="comment"> * 1.1 renames RSA_PKCS1_SSLeay to RSA_PKCS1_OpenSSL</span></div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="comment"> * use RSA_PKCS1_OpenSSL</span></div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="comment"> * Previous versions are missing a number of functions to access</span></div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="comment"> * some hidden structures. Define them here:</span></div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment">/*  EVP_PKEY_base_id introduced in 1.0.1 */</span></div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="preprocessor">#if OPENSSL_VERSION_NUMBER &lt; 0x10001000L</span></div><div class="line"><a name="l00080"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#af3c8110313c5087c523740e6c757df2d">   80</a></span>&#160;<span class="preprocessor">#define EVP_PKEY_base_id(x)             (x-&gt;type)</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="preprocessor">#if OPENSSL_VERSION_NUMBER &lt; 0x10100000L</span></div><div class="line"><a name="l00084"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#aba98397d688551e8701638a7db9b6a6f">   84</a></span>&#160;<span class="preprocessor">#define RSA_PKCS1_OpenSSL               RSA_PKCS1_SSLeay</span></div><div class="line"><a name="l00085"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a6f5db5a35432108963a900dfb8bb46f6">   85</a></span>&#160;<span class="preprocessor">#define OPENSSL_malloc_init             CRYPTO_malloc_init</span></div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a82998315fc1b2d130739ab1f4c8b28fa">   87</a></span>&#160;<span class="preprocessor">#define EVP_PKEY_get0_RSA(x)            (x-&gt;pkey.rsa)</span></div><div class="line"><a name="l00088"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a8f37f62b5f004c4659b2e381e58aa4c8">   88</a></span>&#160;<span class="preprocessor">#define EVP_PKEY_get0_DSA(x)            (x-&gt;pkey.dsa)</span></div><div class="line"><a name="l00089"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#ae85c50b457f71d12d22937e238a39ea7">   89</a></span>&#160;<span class="preprocessor">#define X509_get_extension_flags(x)     (x-&gt;ex_flags)</span></div><div class="line"><a name="l00090"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a8a88008c47c312317e0851801ca65a53">   90</a></span>&#160;<span class="preprocessor">#define X509_get_key_usage(x)           (x-&gt;ex_kusage)</span></div><div class="line"><a name="l00091"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#ad48dca6e55e306c7b0f676ef1106d168">   91</a></span>&#160;<span class="preprocessor">#define X509_get_extended_key_usage(x)  (x-&gt;ex_xkusage)</span></div><div class="line"><a name="l00092"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#aca352f2c6540bca1310c6c790ad31b86">   92</a></span>&#160;<span class="preprocessor">#define EVP_MD_CTX_new                  EVP_MD_CTX_create</span></div><div class="line"><a name="l00093"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#ac81f784d435f45050424f80ebc798bbd">   93</a></span>&#160;<span class="preprocessor">#define EVP_MD_CTX_free                 EVP_MD_CTX_destroy</span></div><div class="line"><a name="l00094"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a7d6540ec3023fd1f5994a5861120c165">   94</a></span>&#160;<span class="preprocessor">#define EVP_PKEY_up_ref(user_key)       CRYPTO_add(&amp;user_key-&gt;references, 1, CRYPTO_LOCK_EVP_PKEY)</span></div><div class="line"><a name="l00095"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a4b1f2188102b5b992725103d76c03e09">   95</a></span>&#160;<span class="preprocessor">#define X509_up_ref(cert)               CRYPTO_add(&amp;cert-&gt;references, 1, CRYPTO_LOCK_X509)</span></div><div class="line"><a name="l00096"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#affa896614d21758c003c6feef17ab303">   96</a></span>&#160;<span class="preprocessor">#define X509_get0_tbs_sigalg(x)         (x-&gt;cert_info-&gt;key-&gt;algor)</span></div><div class="line"><a name="l00097"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a0e81b9deaa7e485cde1290d631d6f1a4">   97</a></span>&#160;<span class="preprocessor">#define X509_OBJECT_get0_X509(x)        (x-&gt;data.x509)</span></div><div class="line"><a name="l00098"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a805725ad203250adff25c356c27a2f49">   98</a></span>&#160;<span class="preprocessor">#define X509_OBJECT_get0_X509_CRL(x)    (x-&gt;data.crl)</span></div><div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a6bd5e93026d0075e07e6da8a1632ff65">   99</a></span>&#160;<span class="preprocessor">#define RSA_get0_e(x) (x-&gt;e)</span></div><div class="line"><a name="l00100"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#aab00c5b0f45f8f0a465ee9fe80944163">  100</a></span>&#160;<span class="preprocessor">#define RSA_get0_n(x) (x-&gt;n)</span></div><div class="line"><a name="l00101"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a41794a790bd66bc91cd4e893ea74c761">  101</a></span>&#160;<span class="preprocessor">#define ECDSA_SIG_get0_r(x) (x-&gt;r)</span></div><div class="line"><a name="l00102"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a6801f309896ec47368718fb6148ced95">  102</a></span>&#160;<span class="preprocessor">#define ECDSA_SIG_get0_s(x) (x-&gt;s)</span></div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a02910a9828393e10b344d51fa24af3b4">  104</a></span>&#160;<span class="preprocessor">#define X509_OBJECT_free(x) ({ \</span></div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="preprocessor">        if (x) { \</span></div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="preprocessor">                X509_OBJECT_free_contents(x); \</span></div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="preprocessor">                OPENSSL_free(x); \</span></div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="preprocessor">                } \</span></div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="preprocessor">        })</span></div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="comment"> * OpenSSL-1.1.0-pre5 has hidden the RSA and DSA structures</span></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="comment"> * One can no longer use statements like rsa-&gt;n = ...</span></div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="comment"> * Macros and defines don&#39;t work on all systems, so use inline versions</span></div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="comment"> * If that is not good enough, vsersions could be added to libopensc</span></div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="preprocessor">#if OPENSSL_VERSION_NUMBER &lt; 0x10100000L</span></div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="comment">/* based on OpenSSL-1.1.0 e_os2.h */</span></div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="comment">/* pam_pkcs11_ossl_inline: portable inline definition usable in public headers */</span></div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="preprocessor"># if !defined(inline) &amp;&amp; !defined(__cplusplus)</span></div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="preprocessor">#  if defined(__STDC_VERSION__) &amp;&amp; __STDC_VERSION__&gt;=199901L</span></div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;   <span class="comment">/* just use inline */</span></div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="preprocessor">#   define pam_pkcs11_ossl_inline inline</span></div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="preprocessor">#  elif defined(__GNUC__) &amp;&amp; __GNUC__&gt;=2</span></div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="preprocessor">#   define pam_pkcs11_ossl_inline __inline__</span></div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="preprocessor">#  elif defined(_MSC_VER)</span></div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="preprocessor">#   define pam_pkcs11_ossl_inline __inline</span></div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<span class="preprocessor">#  else</span></div><div class="line"><a name="l00132"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a7dfbb406a64e5303866e0cb53aec80ef">  132</a></span>&#160;<span class="preprocessor">#   define pam_pkcs11_ossl_inline</span></div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="preprocessor">#  endif</span></div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<span class="preprocessor"># else</span></div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="preprocessor">#  define pam_pkcs11_ossl_inline inline</span></div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;<span class="preprocessor"># endif</span></div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="preprocessor">#if OPENSSL_VERSION_NUMBER &lt; 0x10100000L</span></div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div><div class="line"><a name="l00141"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#adb0065957b4ea1e9aabe91d2e7cf98f0">  141</a></span>&#160;<span class="preprocessor">#define RSA_bits(R) (BN_num_bits(R-&gt;n))</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="preprocessor">#include &lt;openssl/bn.h&gt;</span></div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="preprocessor">#ifndef OPENSSL_NO_RSA</span></div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="preprocessor">#include &lt;openssl/rsa.h&gt;</span></div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="preprocessor">#ifndef OPENSSL_NO_DSA</span></div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="preprocessor">#include &lt;openssl/dsa.h&gt;</span></div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="preprocessor">#if 1</span></div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;<span class="preprocessor">#ifndef OPENSSL_NO_RSA</span></div><div class="line"><a name="l00153"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a7d8786ba89d85f9c55a4d6f36dec24ef">  153</a></span>&#160;<span class="keyword">static</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#a7dfbb406a64e5303866e0cb53aec80ef">pam_pkcs11_ossl_inline</a> <span class="keywordtype">int</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#a7d8786ba89d85f9c55a4d6f36dec24ef">RSA_set0_key</a>(RSA *r, BIGNUM *n, BIGNUM *e, BIGNUM *d)</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;{</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    <span class="comment">/* d is the private component and may be NULL */</span></div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    <span class="keywordflow">if</span> (n == NULL || e == NULL)</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        <span class="keywordflow">return</span> 0;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    BN_free(r-&gt;n);</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    BN_free(r-&gt;e);</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    BN_free(r-&gt;d);</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    r-&gt;n = n;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    r-&gt;e = e;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    r-&gt;d = d;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    <span class="keywordflow">return</span> 1;</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;}</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div><div class="line"><a name="l00169"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a46000fdf6f8907fa8dc34aff79920159">  169</a></span>&#160;<span class="keyword">static</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#a7dfbb406a64e5303866e0cb53aec80ef">pam_pkcs11_ossl_inline</a> <span class="keywordtype">int</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#a46000fdf6f8907fa8dc34aff79920159">RSA_set0_factors</a>(RSA *r, BIGNUM *p, BIGNUM *q)</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;{</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    <span class="keywordflow">if</span> (p == NULL || q == NULL)</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        <span class="keywordflow">return</span> 0;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    BN_free(r-&gt;p);</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    BN_free(r-&gt;q);</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    r-&gt;p = p;</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    r-&gt;q = q;</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    <span class="keywordflow">return</span> 1;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;}</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div><div class="line"><a name="l00182"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a908dc4abe5544e2556ed5b3fe9be26be">  182</a></span>&#160;<span class="keyword">static</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#a7dfbb406a64e5303866e0cb53aec80ef">pam_pkcs11_ossl_inline</a> <span class="keywordtype">int</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#a908dc4abe5544e2556ed5b3fe9be26be">RSA_set0_crt_params</a>(RSA *r, BIGNUM *dmp1, BIGNUM *dmq1, BIGNUM *iqmp)</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;{</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    <span class="keywordflow">if</span> (dmp1 == NULL || dmq1 == NULL || iqmp == NULL)</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        <span class="keywordflow">return</span> 0;</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    BN_free(r-&gt;dmp1);</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    BN_free(r-&gt;dmq1);</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    BN_free(r-&gt;iqmp);</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;    r-&gt;dmp1 = dmp1;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    r-&gt;dmq1 = dmq1;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    r-&gt;iqmp = iqmp;</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    <span class="keywordflow">return</span> 1;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;}</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;</div><div class="line"><a name="l00197"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#acc9abcd9e86c74527180d09ad6749485">  197</a></span>&#160;<span class="keyword">static</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#a7dfbb406a64e5303866e0cb53aec80ef">pam_pkcs11_ossl_inline</a> <span class="keywordtype">void</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#acc9abcd9e86c74527180d09ad6749485">RSA_get0_key</a>(<span class="keyword">const</span> RSA *r, <span class="keyword">const</span> BIGNUM **n, <span class="keyword">const</span> BIGNUM **e, <span class="keyword">const</span> BIGNUM **d)</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;{</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    <span class="keywordflow">if</span> (n != NULL)</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        *n = r-&gt;n;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    <span class="keywordflow">if</span> (e != NULL)</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        *e = r-&gt;e;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    <span class="keywordflow">if</span> (d != NULL)</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        *d = r-&gt;d;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;}</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div><div class="line"><a name="l00207"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#acc879574b4e32408f15f5d4178cba072">  207</a></span>&#160;<span class="keyword">static</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#a7dfbb406a64e5303866e0cb53aec80ef">pam_pkcs11_ossl_inline</a> <span class="keywordtype">void</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#acc879574b4e32408f15f5d4178cba072">RSA_get0_factors</a>(<span class="keyword">const</span> RSA *r, <span class="keyword">const</span> BIGNUM **p, <span class="keyword">const</span> BIGNUM **q)</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;{</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    <span class="keywordflow">if</span> (p != NULL)</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        *p = r-&gt;p;</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    <span class="keywordflow">if</span> (q != NULL)</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;        *q = r-&gt;q;</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;}</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;</div><div class="line"><a name="l00215"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#abcdac237b83944ba335f66c409a69dd7">  215</a></span>&#160;<span class="keyword">static</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#a7dfbb406a64e5303866e0cb53aec80ef">pam_pkcs11_ossl_inline</a> <span class="keywordtype">void</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#abcdac237b83944ba335f66c409a69dd7">RSA_get0_crt_params</a>(<span class="keyword">const</span> RSA *r,</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;                         <span class="keyword">const</span> BIGNUM **dmp1, <span class="keyword">const</span> BIGNUM **dmq1, <span class="keyword">const</span> BIGNUM **iqmp)</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;{</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    <span class="keywordflow">if</span> (dmp1 != NULL)</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        *dmp1 = r-&gt;dmp1;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    <span class="keywordflow">if</span> (dmq1 != NULL)</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        *dmq1 = r-&gt;dmq1;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    <span class="keywordflow">if</span> (iqmp != NULL)</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        *iqmp = r-&gt;iqmp;</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;}</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* OPENSSL_NO_RSA */</span><span class="preprocessor"></span></div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;<span class="preprocessor">#ifndef OPENSSL_NO_DSA</span></div><div class="line"><a name="l00229"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#acd202c0bd6fd5c5406e4b293bf76fe16">  229</a></span>&#160;<span class="keyword">static</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#a7dfbb406a64e5303866e0cb53aec80ef">pam_pkcs11_ossl_inline</a> <span class="keywordtype">void</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#acd202c0bd6fd5c5406e4b293bf76fe16">DSA_get0_pqg</a>(<span class="keyword">const</span> DSA *d, <span class="keyword">const</span> BIGNUM **p, <span class="keyword">const</span> BIGNUM **q, <span class="keyword">const</span> BIGNUM **g)</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;{</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;    <span class="keywordflow">if</span> (p != NULL)</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;        *p = d-&gt;p;</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;    <span class="keywordflow">if</span> (q != NULL)</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;        *q = d-&gt;q;</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    <span class="keywordflow">if</span> (g != NULL)</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        *g = d-&gt;g;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;}</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;</div><div class="line"><a name="l00239"></a><span class="lineno"><a class="line" href="pam-pkcs11-ossl-compat_8h.html#a1a824b4930d450d899bb9e390182128a">  239</a></span>&#160;<span class="keyword">static</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#a7dfbb406a64e5303866e0cb53aec80ef">pam_pkcs11_ossl_inline</a> <span class="keywordtype">void</span> <a class="code" href="pam-pkcs11-ossl-compat_8h.html#a1a824b4930d450d899bb9e390182128a">DSA_get0_key</a>(<span class="keyword">const</span> DSA *d, <span class="keyword">const</span> BIGNUM **pub_key, <span class="keyword">const</span> BIGNUM **priv_key)</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;{</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;    <span class="keywordflow">if</span> (pub_key != NULL)</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        *pub_key = d-&gt;pub_key;</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    <span class="keywordflow">if</span> (priv_key != NULL)</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        *priv_key = d-&gt;priv_key;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;}</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;<span class="comment">/* NOTE: DSA_set0_*  functions not defined because they are not currently used in OpenSC */</span></div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* OPENSSL_NO_DSA */</span><span class="preprocessor"></span></div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;<span class="preprocessor">#else </span><span class="comment">/* if we used macros */</span><span class="preprocessor"></span></div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;<span class="preprocessor">#define RSA_set0_key(R, N, E, D) \</span></div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;<span class="preprocessor">        ({ \</span></div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;<span class="preprocessor">                int ret = 0; \</span></div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;<span class="preprocessor">                if (!(N) || !(E)) { \</span></div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;<span class="preprocessor">                        ret = 0; \</span></div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;<span class="preprocessor">                } else { \</span></div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;<span class="preprocessor">                        BN_free(R-&gt;n); \</span></div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;<span class="preprocessor">                        BN_free(R-&gt;e); \</span></div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;<span class="preprocessor">                        BN_free(R-&gt;d); \</span></div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;<span class="preprocessor">                        R-&gt;n = (N); \</span></div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;<span class="preprocessor">                        R-&gt;e = (E); \</span></div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;<span class="preprocessor">                        R-&gt;d = (D); \</span></div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;<span class="preprocessor">                        ret = 1; \</span></div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;<span class="preprocessor">                } \</span></div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;<span class="preprocessor">                ret; \</span></div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;<span class="preprocessor">        })</span></div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;<span class="preprocessor">#define RSA_set0_factors(R, P, Q) \</span></div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;<span class="preprocessor">         ({ \</span></div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;<span class="preprocessor">                int ret= 0; \</span></div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;<span class="preprocessor">                if (!P || !Q) { \</span></div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;<span class="preprocessor">                        ret = 0; \</span></div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;<span class="preprocessor">                } else { \</span></div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;<span class="preprocessor">                        BN_free(R-&gt;p); \</span></div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;<span class="preprocessor">                        BN_free(R-&gt;q); \</span></div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;<span class="preprocessor">                        R-&gt;p = P; \</span></div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;<span class="preprocessor">                        R-&gt;q = Q; \</span></div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;<span class="preprocessor">                        ret = 1; \</span></div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;<span class="preprocessor">                } \</span></div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;<span class="preprocessor">                ret; \</span></div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;<span class="preprocessor">        })</span></div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;<span class="preprocessor">#define RSA_set0_crt_params(R, DMP1, DMQ1, IQMP) \</span></div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;<span class="preprocessor">        ({ \</span></div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;<span class="preprocessor">                int ret = 0; \</span></div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;<span class="preprocessor">                if (!DMP1 || !DMQ1 || !IQMP) { \</span></div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;<span class="preprocessor">                         ret = 0; \</span></div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;<span class="preprocessor">                } else { \</span></div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;<span class="preprocessor">                        BN_free(R-&gt;dmp1); \</span></div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;<span class="preprocessor">                        BN_free(R-&gt;dmq1); \</span></div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;<span class="preprocessor">                        BN_free(R-&gt;iqmp); \</span></div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;<span class="preprocessor">                        R-&gt;dmp1 = DMP1; \</span></div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;<span class="preprocessor">                        R-&gt;dmq1 = DMQ1; \</span></div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;<span class="preprocessor">                        R-&gt;iqmp = IQMP; \</span></div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;<span class="preprocessor">                        ret = 1; \</span></div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;<span class="preprocessor">                } \</span></div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;<span class="preprocessor">                ret; \</span></div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;<span class="preprocessor">        })</span></div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;<span class="preprocessor">#define RSA_get0_key(R, N, E, D) { \</span></div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;<span class="preprocessor">        BIGNUM **n = N; \</span></div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;<span class="preprocessor">        BIGNUM **e = E; \</span></div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;<span class="preprocessor">        BIGNUM **d = D; \</span></div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;<span class="preprocessor">        if (n) *(n) = R-&gt;n; \</span></div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;<span class="preprocessor">        if (e) *(e) = R-&gt;e; \</span></div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;<span class="preprocessor">        if (d) *(d) = R-&gt;d; \</span></div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;<span class="preprocessor">        }</span></div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;<span class="preprocessor">#define RSA_get0_factors(R, P, Q) {\</span></div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;<span class="preprocessor">        BIGNUM **p = P; \</span></div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;<span class="preprocessor">        BIGNUM **q = Q; \</span></div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;<span class="preprocessor">        if (p) *(p) = R-&gt;p; \</span></div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;<span class="preprocessor">        if (q) *(q) = R-&gt;q; \</span></div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;<span class="preprocessor">        }</span></div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;<span class="preprocessor">#define RSA_get0_crt_params(R, DMP1, DMQ1, IQMP) { \</span></div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;<span class="preprocessor">        BIGNUM **dmp1 = DMP1; \</span></div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;<span class="preprocessor">        BIGNUM **dmq1 = DMQ1; \</span></div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;<span class="preprocessor">        BIGNUM **iqmp = IQMP; \</span></div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;<span class="preprocessor">        if (dmp1) *(dmp1) = R-&gt;dmp1; \</span></div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;<span class="preprocessor">        if (dmq1) *(dmq1) = R-&gt;dmq1; \</span></div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;<span class="preprocessor">        if (iqmp) *(iqmp) = R-&gt;iqmp; \</span></div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;<span class="preprocessor">        }</span></div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;<span class="preprocessor">#define DSA_get0_key(D, PUB, PRIV) { \</span></div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;<span class="preprocessor">        BIGNUM **pub = PUB; \</span></div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;<span class="preprocessor">        BIGNUM **priv = PRIV; \</span></div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;<span class="preprocessor">        if (pub) *(pub) = D-&gt;pub_key; \</span></div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;<span class="preprocessor">        if (priv) *(priv) = D-&gt;priv_key; \</span></div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;<span class="preprocessor">        }</span></div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;<span class="preprocessor">#define DSA_get0_pqg(D, P, Q, G) { \</span></div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;<span class="preprocessor">        BIGNUM **p = P; \</span></div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;<span class="preprocessor">        BIGNUM **q = Q; \</span></div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;<span class="preprocessor">        BIGNUM **g = G; \</span></div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;<span class="preprocessor">        if (p) *(p) = D-&gt;p; \</span></div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;<span class="preprocessor">        if (q) *(q) = D-&gt;q; \</span></div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;<span class="preprocessor">        if (g) *(g) = D-&gt;g; \</span></div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;<span class="preprocessor">        }</span></div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;<span class="comment">/* NOTE: DSA_set0_*  functions not defined because they are not used in OpenSC */</span></div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* 0 */</span><span class="preprocessor"></span></div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;<span class="preprocessor">#ifdef __cplusplus</span></div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;}</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="pam-pkcs11-ossl-compat_8h_html_a46000fdf6f8907fa8dc34aff79920159"><div class="ttname"><a href="pam-pkcs11-ossl-compat_8h.html#a46000fdf6f8907fa8dc34aff79920159">RSA_set0_factors</a></div><div class="ttdeci">static pam_pkcs11_ossl_inline int RSA_set0_factors(RSA *r, BIGNUM *p, BIGNUM *q)</div><div class="ttdef"><b>Definition:</b> <a href="pam-pkcs11-ossl-compat_8h_source.html#l00169">pam-pkcs11-ossl-compat.h:169</a></div></div>
<div class="ttc" id="pam-pkcs11-ossl-compat_8h_html_acc879574b4e32408f15f5d4178cba072"><div class="ttname"><a href="pam-pkcs11-ossl-compat_8h.html#acc879574b4e32408f15f5d4178cba072">RSA_get0_factors</a></div><div class="ttdeci">static pam_pkcs11_ossl_inline void RSA_get0_factors(const RSA *r, const BIGNUM **p, const BIGNUM **q)</div><div class="ttdef"><b>Definition:</b> <a href="pam-pkcs11-ossl-compat_8h_source.html#l00207">pam-pkcs11-ossl-compat.h:207</a></div></div>
<div class="ttc" id="pam-pkcs11-ossl-compat_8h_html_a1a824b4930d450d899bb9e390182128a"><div class="ttname"><a href="pam-pkcs11-ossl-compat_8h.html#a1a824b4930d450d899bb9e390182128a">DSA_get0_key</a></div><div class="ttdeci">static pam_pkcs11_ossl_inline void DSA_get0_key(const DSA *d, const BIGNUM **pub_key, const BIGNUM **priv_key)</div><div class="ttdef"><b>Definition:</b> <a href="pam-pkcs11-ossl-compat_8h_source.html#l00239">pam-pkcs11-ossl-compat.h:239</a></div></div>
<div class="ttc" id="pam-pkcs11-ossl-compat_8h_html_a7dfbb406a64e5303866e0cb53aec80ef"><div class="ttname"><a href="pam-pkcs11-ossl-compat_8h.html#a7dfbb406a64e5303866e0cb53aec80ef">pam_pkcs11_ossl_inline</a></div><div class="ttdeci">#define pam_pkcs11_ossl_inline</div><div class="ttdef"><b>Definition:</b> <a href="pam-pkcs11-ossl-compat_8h_source.html#l00132">pam-pkcs11-ossl-compat.h:132</a></div></div>
<div class="ttc" id="pam-pkcs11-ossl-compat_8h_html_a7d8786ba89d85f9c55a4d6f36dec24ef"><div class="ttname"><a href="pam-pkcs11-ossl-compat_8h.html#a7d8786ba89d85f9c55a4d6f36dec24ef">RSA_set0_key</a></div><div class="ttdeci">static pam_pkcs11_ossl_inline int RSA_set0_key(RSA *r, BIGNUM *n, BIGNUM *e, BIGNUM *d)</div><div class="ttdef"><b>Definition:</b> <a href="pam-pkcs11-ossl-compat_8h_source.html#l00153">pam-pkcs11-ossl-compat.h:153</a></div></div>
<div class="ttc" id="pam-pkcs11-ossl-compat_8h_html_acc9abcd9e86c74527180d09ad6749485"><div class="ttname"><a href="pam-pkcs11-ossl-compat_8h.html#acc9abcd9e86c74527180d09ad6749485">RSA_get0_key</a></div><div class="ttdeci">static pam_pkcs11_ossl_inline void RSA_get0_key(const RSA *r, const BIGNUM **n, const BIGNUM **e, const BIGNUM **d)</div><div class="ttdef"><b>Definition:</b> <a href="pam-pkcs11-ossl-compat_8h_source.html#l00197">pam-pkcs11-ossl-compat.h:197</a></div></div>
<div class="ttc" id="pam-pkcs11-ossl-compat_8h_html_a908dc4abe5544e2556ed5b3fe9be26be"><div class="ttname"><a href="pam-pkcs11-ossl-compat_8h.html#a908dc4abe5544e2556ed5b3fe9be26be">RSA_set0_crt_params</a></div><div class="ttdeci">static pam_pkcs11_ossl_inline int RSA_set0_crt_params(RSA *r, BIGNUM *dmp1, BIGNUM *dmq1, BIGNUM *iqmp)</div><div class="ttdef"><b>Definition:</b> <a href="pam-pkcs11-ossl-compat_8h_source.html#l00182">pam-pkcs11-ossl-compat.h:182</a></div></div>
<div class="ttc" id="pam-pkcs11-ossl-compat_8h_html_acd202c0bd6fd5c5406e4b293bf76fe16"><div class="ttname"><a href="pam-pkcs11-ossl-compat_8h.html#acd202c0bd6fd5c5406e4b293bf76fe16">DSA_get0_pqg</a></div><div class="ttdeci">static pam_pkcs11_ossl_inline void DSA_get0_pqg(const DSA *d, const BIGNUM **p, const BIGNUM **q, const BIGNUM **g)</div><div class="ttdef"><b>Definition:</b> <a href="pam-pkcs11-ossl-compat_8h_source.html#l00229">pam-pkcs11-ossl-compat.h:229</a></div></div>
<div class="ttc" id="pam-pkcs11-ossl-compat_8h_html_abcdac237b83944ba335f66c409a69dd7"><div class="ttname"><a href="pam-pkcs11-ossl-compat_8h.html#abcdac237b83944ba335f66c409a69dd7">RSA_get0_crt_params</a></div><div class="ttdeci">static pam_pkcs11_ossl_inline void RSA_get0_crt_params(const RSA *r, const BIGNUM **dmp1, const BIGNUM **dmq1, const BIGNUM **iqmp)</div><div class="ttdef"><b>Definition:</b> <a href="pam-pkcs11-ossl-compat_8h_source.html#l00215">pam-pkcs11-ossl-compat.h:215</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed May 22 2019 12:09:34 for pam_pkcs11 by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
